
class CSplit:
    """
            Split a string by separators

    """
    def __init__(self, *seps):
        """
                Set separators in the parameter *seps
        """
        self.separators = {' '}         #       Default separator
        if len(seps) > 0:               #       The separators are given 
            self.separators = set()
            for v in seps:
                self.separators |= {v}

    def set_string(self, s):
        """
                Set the string s to be splitted
        """
        self.words = []
        if len(s) > 0:
            spos = -1
            epos = 0
            while True:
                while not(s[epos] in self.separators):
                    epos += 1
                    if epos >= len(s):
                        break
                    
                self.words.append(s[spos + 1: epos])
                spos = epos
                epos = spos + 1
                if spos == len(s) - 1:
                    self.words.append("")
                    break
                if spos >= len(s):
                    break

        self.nonempty_words = []        #   Select non empty substrings
        for w in self.words:
            if w != "":
                self.nonempty_words.append(w)

    def seek(self, pos):
        """
                Return the pos-th substring
        """
        if pos >= len(self.words):
            return ""
        else:
            return self.words[pos]

    def seek_nonempty(self, pos):
        """
                Return the pos-th non empty substring
        """
        if pos >= len(self.nonempty_words):
            return ""
        else:
            return self.nonempty_words[pos]

